<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 30.10</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
</head>

<body>
    <form id="login-form">
        <div class="container-fluid" style="height: 500px;display: flex;flex-direction: column;
        justify-content: center;">
            <label for="email">Email address</label>
            <input id="email" type="text" class="form-control" placeholder="Enter Email...">
            <p style="color: grey;">We'll never share your email with anyone else.</p>
            <label for="password">Password</label>
            <input id="password" type="password" class="form-control" placeholder="Enter Password...">
            <button style="margin-top: 20px;width: 100px;" class="btn btn-primary" type="submit">Submit</button>
        </div>
    </form>
</body>
<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_CREATED = 201;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
    const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    var loginForm = document.getElementById("login-form")
    loginForm.addEventListener("submit", (e) => {
        e.preventDefault()
        var User = {
            email: "",
            password: ""
        }
        // B1 thu thap du lieu
        getDataToObject(User)
        // B2  Kiem tra du lieu
        var validate=isDataValidate(User)
        if(validate==true){
            // B3 Goi API xu ly
            var xhr = new XMLHttpRequest()
            processApi(User,xhr)
            xhr.onreadystatechange =
            function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vLoginInfo = xhr.responseText;
                    //B4 Xu Ly Hien Thi
                    console.log(vLoginInfo);
                }
            }
        }
    }
    )
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Ham thu thap du lieu
    function getDataToObject(paramObject) {
        var vEmailInput = document.getElementById("email")
        var vPasswordInput = document.getElementById("password")
        paramObject.email = vEmailInput.value.trim()
        paramObject.password = vPasswordInput.value.trim()
    }
    // Ham kiem tra du lieu
    function isDataValidate(paramObject) {
        if (isEmailValidate(paramObject.email)==false) {
            alert("Email khong hop le")
            return false
        }
        if(paramObject.password==""){
            alert("hay nhap Password")
            return false
        }
        return true
    }
    // Ham kiem tra email
    function isEmailValidate(paramEmail) {
        var re = /^(([^<>()[\]\.,;:\s@\"]+(\.[^<>()[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;
  return re.test(paramEmail);
    }
    //Ham goi API xu ly login
    function processApi(paramObject,paramXmlHttp){
        const vParams = new URLSearchParams(paramObject)
        paramXmlHttp.open("GET", gBASE_URL + "?" + vParams.toString(), true);
        paramXmlHttp.send()
    }

</script>

</html>